#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;


$approve_email = acs::get_file_contents("$data_dir/prem.cfg");
@pconfig = split (/\n/, $approve_email);

if ($pconfig[4] eq "Yes") { $sendmails = "true"; }
if ($pconfig[5] eq "Yes") { $sendmails = "true"; }
if ($pconfig[6] eq "Yes") { $sendmails = "true"; }



if ($sendmails eq "true")
{

#### GET EXTRA FIELDS KEYS DATA

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$today_time = time();


if ($pconfig[4] eq "Yes") ### CHECK FOR LINKS THAT IS ABOUT THE EXPIRE A MONTH FROM NOW
	{
	
	### GET EMAIL THAT IS TO BE SENT
	$email_message = "";
	$emailmsg = acs::get_file_contents("$data_dir/month_exp.eml");
	@elines = split (/\n/, $emailmsg);
	
	$from_name = $elines[0];
	$from_email = $elines[1];
	$email_subject = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}

	
	
	### GET DATES FOR SELECTION CRITERIA
	
	$exp_date_month = $today_time + 2592000; 	### 30 days from now
	
	($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($exp_date_month);
	$year = "20" . substr($year, 1, 2);
	
	$start_time = timelocal(0,0,0, $mday,$mon,$year);
	$end_time = timelocal(59,59,23, $mday,$mon,$year);
	
	#$ss =  acs::decode_date($start_time);
	#print "--> $ss\n";
	
	### FETCH RECORDS FROM DB AND SEND MAIL
	
	$sql = "SELECT * FROM links WHERE 	(premium > 0) AND (subs_expire IS NOT NULL) AND (subs_expire != '') AND
													(subs_expire >= $start_time) AND (subs_expire <= $end_time)";
	
	
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
		while ( @row = $sth->fetchrow() )
		{ 
		if ($row[9] ne "")
			{
			$tmp_email_msg = $email_message;
			$title = $row[2]; $tmp_email_msg =~ s/%%title%%/$title/gi;
			$description = $row[3]; $tmp_email_msg =~ s/%%description%%/$description/gi;
			$url = $row[5]; $tmp_email_msg =~ s/%%url%%/$url/gi;
			$keywords = $row[4]; $tmp_email_msg =~ s/%%keywords%%/$keywords/gi;
			$name = $row[8]; $tmp_email_msg =~ s/%%name%%/$name/gi;
			$email = $row[9]; $tmp_email_msg =~ s/%%email%%/$email/gi;
			$date = $row[17]; $date = acs::decode_date($date); $tmp_email_msg =~ s/%%date%%/$date/gi;

			### EXTRA FIELDS
			$fcount = 27;
			foreach $k_item (@akeys)
				{
				($keyname, $visible, $size, $searched, $description1, $na, $imgk) = split (/\t/, $k_item);
				$currfield = $row[$fcount];
				$varkeyname = "%%" . $keyname . "%%";
				$tmp_email_msg =~ s/$varkeyname/$currfield/gi;
				$fcount++;
				}	

			
			acs::send_email ($from_name, $from_email, $email, $email_subject, $tmp_email_msg);
			}
		}
	
	
	}


############################


	if ($pconfig[5] eq "Yes") ### CHECK FOR LINKS THAT IS ABOUT THE EXPIRE A WEEK FROM NOW
	{

	### GET EMAIL THAT IS TO BE SENT
	$email_message = "";
	$emailmsg = acs::get_file_contents("$data_dir/week_exp.eml");
	@elines = split (/\n/, $emailmsg);
	
	$from_name = $elines[0];
	$from_email = $elines[1];
	$email_subject = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}	
	

	### GET DATES FOR SELECTION CRITERIA
	
	$exp_date_month = $today_time + 604800; 	### 7 days from now
	
	($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($exp_date_month);
	$year = "20" . substr($year, 1, 2);
	
	$start_time = timelocal(0,0,0, $mday,$mon,$year);
	$end_time = timelocal(59,59,23, $mday,$mon,$year);
	
	
	#$ss =  acs::decode_date($start_time);
	#print "--> $ss\n";
	

	### FETCH RECORDS FROM DB AND SEND MAIL
	
	$sql = "SELECT * FROM links WHERE 	(premium > 0) AND (subs_expire IS NOT NULL) AND (subs_expire != '') AND
													(subs_expire >= $start_time) AND (subs_expire <= $end_time)";
	
	
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
		while ( @row = $sth->fetchrow() )
		{ 
		
		if ($row[9] ne "")
			{
			$tmp_email_msg = $email_message;
			$title = $row[2]; $tmp_email_msg =~ s/%%title%%/$title/gi;
			$description = $row[3]; $tmp_email_msg =~ s/%%description%%/$description/gi;
			$url = $row[5]; $tmp_email_msg =~ s/%%url%%/$url/gi;
			$keywords = $row[4]; $tmp_email_msg =~ s/%%keywords%%/$keywords/gi;
			$name = $row[8]; $tmp_email_msg =~ s/%%name%%/$name/gi;
			$email = $row[9]; $tmp_email_msg =~ s/%%email%%/$email/gi;
			$date = $row[17]; $date = acs::decode_date($date); $tmp_email_msg =~ s/%%date%%/$date/gi;


			### EXTRA FIELDS
			$fcount = 27;
			foreach $k_item (@akeys)
				{
				($keyname, $visible, $size, $searched, $description1, $na, $imgk) = split (/\t/, $k_item);
				$currfield = $row[$fcount];
				$varkeyname = "%%" . $keyname . "%%";
				$tmp_email_msg =~ s/$varkeyname/$currfield/gi;
				$fcount++;
				}	
			
			acs::send_email ($from_name, $from_email, $email, $email_subject, $tmp_email_msg);
			}
		}
	
	
	}




##########################


	if ($pconfig[6] eq "Yes") ### CHECK FOR LINKS THAT HAS EXPIRED
	{


	### GET EMAIL THAT IS TO BE SENT
	$email_message = "";
	$emailmsg = acs::get_file_contents("$data_dir/expired_email.eml");
	@elines = split (/\n/, $emailmsg);
	
	$from_name = $elines[0];
	$from_email = $elines[1];
	$email_subject = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}	
		


	### GET DATES FOR SELECTION CRITERIA
	
	$exp_date_month = $today_time - 86400; 	### Minus 1 Day (expired yesterday)
	
	($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($exp_date_month);
	$year = "20" . substr($year, 1, 2);
	
	$start_time = timelocal(0,0,0, $mday,$mon,$year);
	$end_time = timelocal(59,59,23, $mday,$mon,$year);
	
	
	#$ss =  acs::decode_date($start_time);
	#print "--> $ss\n";
	

	### FETCH RECORDS FROM DB AND SEND MAIL
	
	$sql = "SELECT * FROM links WHERE 	(premium > 0) AND (subs_expire IS NOT NULL) AND (subs_expire != '') AND
													(subs_expire >= $start_time) AND (subs_expire <= $end_time)";
	
	
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	
		while ( @row = $sth->fetchrow() )
		{ 
		
		if ($row[9] ne "")
			{
			$tmp_email_msg = $email_message;
			$title = $row[2]; $tmp_email_msg =~ s/%%title%%/$title/gi;
			$description = $row[3]; $tmp_email_msg =~ s/%%description%%/$description/gi;
			$url = $row[5]; $tmp_email_msg =~ s/%%url%%/$url/gi;
			$keywords = $row[4]; $tmp_email_msg =~ s/%%keywords%%/$keywords/gi;
			$name = $row[8]; $tmp_email_msg =~ s/%%name%%/$name/gi;
			$email = $row[9]; $tmp_email_msg =~ s/%%email%%/$email/gi;
			$date = $row[17]; $date = acs::decode_date($date); $tmp_email_msg =~ s/%%date%%/$date/gi;

			### EXTRA FIELDS
			$fcount = 27;
			foreach $k_item (@akeys)
				{
				($keyname, $visible, $size, $searched, $description1, $na, $imgk) = split (/\t/, $k_item);
				$currfield = $row[$fcount];
				$varkeyname = "%%" . $keyname . "%%";
				$tmp_email_msg =~ s/$varkeyname/$currfield/gi;
				$fcount++;
				}	
			
			acs::send_email ($from_name, $from_email, $email, $email_subject, $tmp_email_msg);
			}
		}
	
	
	}




if (defined($sth))
	{
	$sth->finish;
	}
$dbh->disconnect;

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

